#if !defined (__PLAYER_HPP)
#define __PLAYER_HPP

#include "point.hpp"

class WormPoint : public Point
{
public:
  WormPoint(int initX, int initY, int initColor);
  WormPoint *Next;       // Pekare till nsta nod i listan
  WormPoint *Prev;       // Pekare till fregende nod i listan
};

enum Direction   { right, down, left, up };

class Worm
{
public:
  int       head_x;                              // Huvudets x koord
  int       head_y;                              // Huvudets y koord
  Boolean   grow;                                // Status skall vxa
  int       score;

  Worm();                                        // Konstruktor

  void Setup(int InitX, int InitY,               // Initierar en spelare
             Direction InitDir, int InitColor,
             char InitKeyR, char InitKeyL, char InitKeyT);
  void AddPoint();                               // Lgg till en maskpunkt
  int Kollision(int c1, int c2=-1, int c3=-1,    // Kolla efter kollision
                int c4=-1, int c5=-1);
  void CheckKeys(char Ch);                       // Kolla tangentbordet
  void CalcNewPos();                             // Rkna ut ny position
  void WormMove();                               // Flytta masken framt
  Boolean Bury(Boolean make_noice);              // Begrav masken
  int GetLength() { return length; };
  Boolean IsDead() { return dead; };
  Boolean IsBuried() { return buried; };
  void Kill() { dead = true; };

private:
  Direction dir;                                 // Krriktning
  char      key_right;                           // Styrtangent hger
  char      key_left;                            // Styrtangent vnster
  char      key_tail;                            // Styrtangent ka svans
  Boolean   dead;                                // Status dd
  Boolean   buried;                              // Status begravd
  WormPoint *Head;                               // Frsta punkten
  WormPoint *Tail;                               // Sista punkten
  int       cntr;                                // Rknare vid begravning
  int       color;                               // Frg
  int       length;                              // Lngd

  void RemovePoint();                            // Ta bort en maskpunkt
};

#endif // __PLAYER_HPP
